.windows_runner:
  tags:
    - windows
.macos_runner:
  tags:
    - shared-macos-amd64

cache:
  paths:
    - .m2/repository
    - .mvn
    - ./**/target

variables:
  MAVEN_OPTS: "-Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository"

stages:
  - build
  - validation
  - bundle

image: maven:3.8.7-eclipse-temurin-17-alpine

build:
  stage: build
  script:
    - echo "Building..."
    - ./mvnw clean test-compile

unit-tests:
  stage: validation
  dependencies:
    - build
  script:
    - echo "Running tests..."
    - ./mvnw test

package-linux:
  stage: bundle
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
  dependencies:
    - unit-tests
  script:
    - echo "Packaging software..."
    - ./mvnw package -DskipTests
artifacts-linux:
  stage: bundle
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
  needs:
    - package-linux
  script:
    - echo "Bundling software..."
    - mkdir bundle
    - mv bwyn/target/bwyn.jar ./bundle/
    - mv bwyn/target/bwyn/scripts/bwyn ./bundle/
    - mv runtime/target/maven-jlink/default ./bundle/runtime
  artifacts:
    name: bwyn-linux
    paths:
      - bundle

package-windows:
  extends:
    - .windows_runner
  stage: bundle
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
  dependencies:
    - unit-tests
  script:
    - echo "Packaging software..."
    - java --version
    - .\mvnw.cmd package -DskipTests
artifacts-windows:
  extends:
    - .windows_runner
  stage: bundle
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
  needs:
    - package-windows
  script:
    - echo "Bundling software..."
    - mkdir bundle
    - mv bwyn/target/bwyn.jar ./bundle/
    - mv bwyn/target/bwyn/scripts/bwyn ./bundle/
    - mv runtime/target/maven-jlink/default ./bundle/runtime
  artifacts:
    name: bwyn-win
    paths:
      - bundle

package-macos:
  extends:
    - .macos_runner
  stage: bundle
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
  dependencies:
    - unit-tests
  script:
    - echo "Packaging software..."
    - .\mvnw.cmd package -DskipTests
artifacts-macos:
  extends:
    - .macos_runner
  stage: bundle
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
  needs:
    - package-macos
  script:
    - echo "Bundling software..."
    - mkdir bundle
    - mv bwyn/target/bwyn.jar ./bundle/
    - mv bwyn/target/bwyn/scripts/bwyn ./bundle/
    - mv runtime/target/maven-jlink/default ./bundle/runtime
  artifacts:
    name: bwyn-macos
    paths:
      - bundle